const { clone } = require("./download");
const chalk = require("chalk");
const log = (content) => console.log(chalk.green(content));

// promisiy化spawn
// 对接输出流
const spawn = async (...args) => {
    const { spawn } = require("child_process");
    return new Promise((resolve) => {
        const proc = spawn(...args);
        proc.stdout.pipe(process.stdout);
        proc.stderr.pipe(process.stderr);
        proc.on("close", () => {
            resolve();
        });
    });
};

module.exports = async (name) => {
  console.log("init " + name);
  log("创建项目:" + name);
  // 从github克隆项目到指定文件夹，格式为github:owner/name
  await clone("github:SierraSoftworks/vue-template", name);
  //   实现自动安装依赖
  //   log("安装依赖");
  //   await spawn("cnpm", ["install"], { cwd: `./${name}` });
  log(
    chalk.green(`
                    安装完成：
                    To get Start:
                    ===========================
                    cd ${name}
                    yarn 
                    yarn serve
                    ===========================
                    `)
  );
//   实现自动跑项目，打开浏览器
//   open(`http://localhost:8080`);
//   await spawn("npm", ["run", "dev"], { cwd: `./${name}` });
};
